;Type :: addon. Name :: Seen system v.1
;Author :: uzklydelis @ Aitvaras NET irc.data.lt :: uzklydelis@mail.com

on *:load: {
  echo -a :: Loading seen system, setting options...
  set %aaseen.cleartime 1209600
  set %aaseen.ignore.time 5
  set %aaseen.prefix !
  set %aaseen.reply msgc
  if (!%aaseen.channels) { set %aaseen.channels }
  set %aaseen.autoclear 1
  set %aaseen.cr
  set %aaseen.chan
  set %aaseen.nick
  set %aaseen.ignore off
  set %aaseen.clear.timer 60
  set %aaseen.status 1
  .enable #aaseen
  if !$hget(aaseen) { hmake aaseen 5000 }
  if ($isfile(aaseen.htb)) hload -b aaseen aaseen.htb
  .timer.aaseen.save 0 60 hsave -ob aaseen aaseen.htb
  .timer.aaseen.autoclear 0 $calc(%aaseen.clear.timer * 60) /seen.clear %aaseen.cleartime
  echo -a :: Loaded...
  echo -a :: Use /+seen command or menubar :: Seen system.
}
on *:unload: {
  echo -a :: Unsettint options, unloading seen system...
  .timer.aaseen.autoclear off
  .timer.aaseen.save off
  if $isfile(aaseen.htb) {
    if $input(Remove seen history?,yv) == $yes {
      hfree aaseen
      remove aaseen.htb
    }
    else {
      hsave -ob aaseen aaseen.htb
      hfree aaseen
      set %aaseen_channels %aaseen.channels
    }
  }
  unset %aaseen.*
  set %aaseen.channels %aaseen_channels
  unset %aaseen_channels
  echo -a :: Unloaded...
}

menu menubar {
  -
  Seen system
  .Settings:/+seen
  .-
  .ReadMe/Help:/run $findfile($mircdir,aaseen_readme.txt,1)
  .-
  .Unload seen:/unload -rs aaseen.mrc
  -
}
#aaseen on
on *:text:*:#: {
  if ($1 == %aaseen.prefix $+ seen) && %aaseen.ignore != on {
    if (# isin %aaseen.channels) {
      if (%aaseen.ignore.time != 0) {
        set %aaseen.ignore on
        .timer 1 %aaseen.ignore.time /set %aaseen.ignore off
      }
      if ($2 == $me) || ($2 == $null) {
        seen.reply Looking for what?
      }
      elseif ($2 == $nick) {
        seen.reply Looking for yourself?
      } 
      elseif ($hget(aaseen,$+($chan,.,$2,.,action)) != $null) && ($2 !ison $chan) {
        if ($hget(aaseen,$+($chan,.,$2,.,action)) == join) { 
          seen.reply Last time i have seen $2 was joining $chan $duration($calc($ctime - $hget(aaseen,$+($chan,.,$2,.,time)))) ago $+ , but now $2 is gone!
        }
        elseif ($hget(aaseen,$+($chan,.,$2,.,action)) == part) { 
          seen.reply $2 parted $chan $duration($calc($ctime - $hget(aaseen,$+($chan,.,$2,.,time)))) ago.
        }
        elseif ($hget(aaseen,$+($chan,.,$2,.,action)) == kick) { 
          seen.reply $2 was kicked from $chan ( $+ $hget(aaseen,$+($chan,.,$2,.,kmessage)) $+ ) $duration($calc($ctime - $hget(aaseen,$+($chan,.,$2,.,time)))) ago.
        }
        elseif ($hget(aaseen,$+($chan,.,$2,.,action)) == quit) {
          seen.reply $2 has quit ( $+ $hget(aaseen,$+($chan,.,$2,.,qmessage)) $+ ) $duration($calc($ctime - $hget(aaseen,$+($chan,.,$2,.,time)))) ago.
        }
        elseif ($hget(aaseen,$+($chan,.,$2,.,action)) == nick) { 
          seen.reply $2 changed nick to $hget(aaseen,$+($chan,.,$2,.,nick)) $duration($calc($ctime - $hget(aaseen,$+($chan,.,$2,.,time)))) ago.
        }
      }
      elseif ($hget(aaseen,$+($chan,.,$2,.,action)) != $null) && ($2 ison $chan) {
        seen.reply $nick look around, $2 is on $chan $+ .
      }
      elseif ($hget(aaseen,$+($chan,.,$2,.,action)) == $null) && ($2 ison $chan) {
        seen.reply $nick look around, $2 is on $chan $+ .
      }
      elseif ($hget(aaseen,$+($chan,.,$2,.,action)) == $null) && ($2 !ison $chan) {
        seen.reply I havent seen $2 on $chan $+ .
      }
    }
  }
}

alias seen.reply {
  if (!%aaseen.reply) { set %aaseen.reply.type msgc }
  if (%aaseen.reply == msgc) { msg # $1- }
  if (%aaseen.reply == msgn) { msg $nick $1- }
  if (%aaseen.reply == notn) { notice $nick $1- }
}

on *:join:#: {
  if (# isin %aaseen.channels) {
    hadd aaseen $+($chan,.,$nick,.,action) join
    hadd aaseen $+($chan,.,$nick,.,time) $ctime
  }
}

on *:part:#: {
  if (# isin %aaseen.channels) {
    hadd aaseen $+($chan,.,$nick,.,action) part
    hadd aaseen $+($chan,.,$nick,.,time) $ctime
  }
}

on *:kick:#: {
  if (# isin %aaseen.channels) {
    hadd aaseen $+($chan,.,$knick,.,action) kick
    hadd aaseen $+($chan,.,$knick,.,time) $ctime
    hadd aaseen $+($chan,.,$knick,.,kmessage) $$1-
  }
}

on *:quit: {
  var %c 1
  while (%c <= $comchan($nick,0)) {
    if ($comchan($nick,%c) isin %aaseen.channels) {
      hadd aaseen $+($comchan($nick,%c),.,$nick,.,action) quit
      hadd aaseen $+($comchan($nick,%c),.,$nick,.,time) $ctime
      hadd aaseen $+($comchan($nick,%c),.,$nick,.,qmessage) $$1-
    }
    inc %c
  }
}

on *:nick: {
  var %c 1
  while (%c <= $comchan($newnick,0)) {
    if ($comchan($newnick,%c) isin %aaseen.channels) {
      hadd aaseen $+($comchan($newnick,%c),.,$nick,.,action) nick
      hadd aaseen $+($comchan($newnick,%c),.,$nick,.,time) $ctime
      hadd aaseen $+($comchan($newnick,%c),.,$nick,.,nick) $newnick
    }
    inc %c
  }
}
#aaseen end

on *:start: {
  aaseen.start
}

on *:exit: {
  if $hget(aaseen) { hsave -ob aaseen aaseen.htb }
}

alias aaseen.start {
  if !$hget(aaseen) { hmake aaseen 5000 }
  if ($isfile(aaseen.htb)) hload -b aaseen aaseen.htb
  .timer.aaseen.save 0 60 hsave -ob aaseen aaseen.htb
}

alias +seen { if !$dialog(seen) { dialog -m seen seen } }
dialog seen {
  title ":: /+seen ::"
  size -1 -1 99 126
  option dbu
  tab "Channels", 7, 1 1 96 107
  list 2, 9 23 80 50, tab 7 size vsbar hsbar sort
  button "Add", 5, 9 88 38 10, tab 7
  button "Remove", 6, 51 88 38 10, tab 7
  edit "", 4, 9 75 80 10, tab 7 autohs
  box "", 10, 4 14 90 90, tab 7
  tab "Options", 8
  box "", 11, 4 14 90 90, tab 8
  radio ".seen", 12, 9 32 25 10, group tab 8
  radio "!seen", 13, 37 32 25 10, tab 8
  radio "`seen", 14, 65 32 25 10, tab 8
  text "Prefix::", 15, 9 23 20 8, tab 8
  text "Send information::", 16, 9 45 45 8, tab 8
  radio "/msg #", 17, 9 54 30 10, group tab 8
  radio "/msg $nick", 18, 47 54 40 10, tab 8
  radio "/notice $nick", 19, 9 67 45 10, tab 8
  text "On seen used ignore for::", 30, 9 80 60 8, tab 8
  text "seconds.", 31, 67 91 22 8, tab 8
  edit "", 32, 9 90 55 10, center tab 8
  tab "History", 9
  box "", 21, 4 14 90 90, tab 9
  check "Auto clear history older than::", 22, 9 23 80 10, tab 9
  radio "5 days", 23, 9 36 28 10, group tab 9
  radio "2 wks", 24, 38 36 25 10, tab 9
  radio "4 wks", 25, 65 36 25 10, tab 9
  button "Clear", 26, 9 48 80 10, tab 9
  text "Set delay in minutes to auto clear seen history::", 27, 9 61 80 13, tab 9
  edit "", 33, 9 76 80 10, tab 9 center
  box "", 34, 4 86 90 4, tab 9
  check "Enable/disable Seen system", 35, 9 93 80 8, tab 9
  button "OK", 28, 53 113 45 10, default ok
  button "ReadMe/Help", 29, 1 113 45 10
}

on *:dialog:seen:sclick:*: {
  if $did == 5 {
    if $did(4).text != $null {
      set %aaseen.channels %aaseen.channels $gettok($did(4).text,1,32)
      did -r $dname 2,4
      seen.addc
      did -z $dname 2
    }
  }
  if $did == 6 {
    if $did(2).seltext != $null {
      set %aaseen.channels $remove(%aaseen.channels,$did(2).seltext)
      set %aaseen.cr $did(2).seltext
      did -r $dname 2
      seen.addc
      did -z $dname 2
      if $input(Clear %aaseen.cr history?,yv) == $yes {
        hdel -w aaseen %aaseen.cr $+ .*
        hsave -ob aaseen aaseen.htb
      }
    }
  }
  if $did(12).state == 1 { set %aaseen.prefix . }
  if $did(13).state == 1 { set %aaseen.prefix ! }
  if $did(14).state == 1 { set %aaseen.prefix ` }
  if $did(17).state == 1 { set %aaseen.reply msgc }
  if $did(18).state == 1 { set %aaseen.reply msgn }
  if $did(19).state == 1 { set %aaseen.reply notn }
  if $did == 22 {
    set %aaseen.autoclear $did(22).state
    if $did(22).state == 1 { did -e $dname 33 }
    if $did(22).state == 0 { did -b $dname 33 }
  }
  if $did(23).state == 1 { set %aaseen.cleartime 432000 }
  if $did(24).state == 1 { set %aaseen.cleartime 1209600 }
  if $did(25).state == 1 { set %aaseen.cleartime 2419200 }
  if $did == 35 {
    set %aaseen.status $did(35).state
    if $did(35).state == 1 { .enable #aaseen | aaseen.start }
    if $did(35).state == 0 { .disable #aaseen | if $hget(aaseen) { hsave -ob aaseen aaseen.htb } | .timer.aaseen.* off | hfree aaseen }
  }
  if $did == 28 {
    if $did(32).text != $null { set %aaseen.ignore.time $did(32).text }
    elseif $did(32).text == $null { set %aaseen.ignore.time 0 }
    set %aaseen.autoclear $did(22).state
    if $did(33).text != $null { set %aaseen.clear.timer $did(33).text }
    elseif $did(33).text == $null { set %aaseen.clear.timer 0 }
    if %aaseen.autoclear == 1 { if !$timer(.seen.autoclear) { .timer.aaseen.autoclear 0 $calc(%aaseen.clear.timer * 60) /seen.clear %aaseen.cleartime } }
    if %aaseen.autoclear == 0 { .timer.aaseen.autoclear off }
  }
  if $did == 26 { if $input(Clear history older than $duration(%aaseen.cleartime) $+ ?,yv) == $yes { seen.clear %aaseen.cleartime } }
  if $did == 29 { run $findfile($mircdir,aaseen_readme.txt,1) }
}

on *:dialog:seen:init:*: {
  seen.addc
  if %aaseen.prefix == . { did -c $dname 12 }
  if %aaseen.prefix == ! { did -c $dname 13 }
  if %aaseen.prefix == ` { did -c $dname 14 }
  if %aaseen.reply == msgc { did -c $dname 17 }
  if %aaseen.reply == msgn { did -c $dname 18 }
  if %aaseen.reply == notn { did -c $dname 19 }
  if %aaseen.cleartime == 432000 { did -c $dname 23 }
  if %aaseen.cleartime == 1209600 { did -c $dname 24 }
  if %aaseen.cleartime == 2419200 { did -c $dname 25 }
  if %aaseen.autoclear == 1 { did -c $dname 22 }
  elseif %aaseen.autoclear == 0 { did -b $dname 33 }
  if %aaseen.status == 1 { did -c $dname 35 }
  did -ra $dname 32 %aaseen.ignore.time
  did -ra $dname 33 %aaseen.clear.timer
}

alias seen.addc { if $dialog(seen) {
    var %c 1
    while (%c <= $gettok(%aaseen.channels,0,32)) {
      did -a seen 2 $gettok(%aaseen.channels,%c,32)
      inc %c
    }
  }
}

alias seen.clear {
  var %h 1
  while (%h <= $hfind(aaseen,*,0,w)) {
    if (*.time iswm $hget(aaseen,%h).item) {
      if ($calc($ctime - $hget(aaseen,%h)) > $1) {
        set %aaseen.chan $gettok($hget(aaseen,%h).item,1,46)
        set %aaseen.nick $gettok($hget(aaseen,%h).item,2,46)
        hdel -w aaseen $+(%aaseen.chan,.,%aaseen.nick,.,*)
      }
    }
    inc %h
  }
  hsave -ob aaseen aaseen.htb
}

;EOF.
